#!/usr/bin/perl

##############################################################################
#
#	dogroupedit.pl	-	This CGI makes the modification and re-direct
#				back to the previous URL (groupedit.pl).
#
#	Author		-	Redvers Davies	
#
#	$Id: dogroupedit.pl,v 1.5 1998/10/31 14:39:30 red Exp red $
#
#	$Log: dogroupedit.pl,v $
#	Revision 1.5  1998/10/31 14:39:30  red
#	replaced open,read,close,chop with read_file()
#
#	Revision 1.4  1998/10/29 01:46:56  red
#	added GPL licence
#
#	Revision 1.3  1998/10/27 20:18:59  red
#	Moved some subroutines out to the library,
#	added Config name so as to create multiple configs
#
#	Revision 1.2  1998/10/22 19:35:07  red
#	Stable version - no arch or name support
#
#	Revision 1.1  1998/10/08 20:46:44  red
#	Initial revision
#
#
##############################################################################

##############################################################################
#
# MKLINUXFW - Modular Firewall Configuration Package
# Copyright Redvers Davies 1998
# 
#     This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# You can contact me by EMail at: red@madhouse.org.uk
#
##############################################################################



require "mklfwlib.pl";

use CGI;
$query = new CGI;

$MYCONFIG	=	$query->param('myconfig');
$DEBUG		=	1;
$DEBUG_FILE	=	"/tmp/dogroupedit.debug";
$FWCONFIGTREE	=	"/tmp/fwconfig/$MYCONFIG";


wr_debug("Started dogroupedit...");


wr_debug("Lets see if we have to add or delete");

if ($query->param('hmmm') =~ /Add/) {
	wr_debug("We have to add");

	## Add networks
	$RET = addnetworks($query);
	print($query->redirect($RET));

} elsif ($query->param('hmmm') =~ /Delete/) {
	wr_debug("We have to delete");

	## Delete Networks
	$RET = delnetworks($query);
	print($query->redirect($RET));

} else {

	wr_debug("I don't exist - I didn't detect add or delete as an option");
	exit(0);

}
	

sub delnetworks {
	$query = $_[0];

	@DELALLTHESE = $query->param('xxx');

	wr_debug("Lets read in the groupfile");

	$DEVICE = $query->param('device');
	$GROUP = $query->param('group');

	@LISTALLIPS = read_file("$FWCONFIGTREE/groups/$DEVICE/$GROUP");
	
	## wipe file first.

	open(FILE_FD, ">$FWCONFIGTREE/groups/$DEVICE/$GROUP");
	close(FILE_FD);
	foreach $LINE (@LISTALLIPS) {
		$RETVAL = check_match($LINE, @DELALLTHESE);

		if ($RETVAL) {
			wr_debug("Deleting $LINE");
			# Alas, I have to delete thee
		} else {
			# I may write thee
			append_file("$FWCONFIGTREE/groups/$DEVICE/$GROUP", "$LINE");
		}
	}
	return("/cgi-bin/groupedit.pl?myconfig=$MYCONFIG&device=$DEVICE&groupname=$GROUP");
}
			

sub addnetworks {
	$query = $_[0];

	@ADDALLTHESE = $query->param('addnet');

	$DEVICE = $query->param('device');
	$GROUP = $query->param('group');
	foreach $LINE_IN (@ADDALLTHESE) {
		$DOME = check_syntax($LINE_IN);
		if ($DOME) {
			wr_debug("File to append to: $FWCONFIGTREE/groups/$DEVICE/$GROUP");
			append_file("$FWCONFIGTREE/groups/$DEVICE/$GROUP", "$DOME");
		}
	}

	return("/cgi-bin/groupedit.pl?myconfig=$MYCONFIG&device=$DEVICE&groupname=$GROUP");
}
