#!/usr/bin/perl

##############################################################################
#
#	doruleedit	-	This CGI adds and deletes rules from the
#				firewall config files.  Similer to dogroupedit.pl
#
#	Author		-	Redvers Davies
#
#	$Id: doruleedit.pl,v 1.3 1998/10/31 14:38:59 red Exp red $
#
#	$Log: doruleedit.pl,v $
#	Revision 1.3  1998/10/31 14:38:59  red
#	added fields for networks to rule-files
#
#	Revision 1.2  1998/10/29 01:46:56  red
#	added GPL licence
#
#	Revision 1.1  1998/10/29 00:39:24  red
#	Initial revision
#
#
##############################################################################

##############################################################################
#
# MKLINUXFW - Modular Firewall Configuration Package
# Copyright Redvers Davies 1998
# 
#     This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# You can contact me by EMail at: red@madhouse.org.uk
#
##############################################################################



require "mklfwlib.pl";

use CGI;
$query = new CGI;

$MYCONFIG	= 	$query->param('myconfig');
$DEBUG		=	1;
$DEBUG_FILE	=	"/tmp/doruleedit.debug";
$FWCONFIGTREE	=	"/tmp/fwconfig/$MYCONFIG";

wr_debug("Started doruleedit.pl");
wr_debug("Lets see if we have to Add or Delete");

if ($query->param('submit') =~ /Add/) {
	wr_debug("It seems in this incarnation my purpose is to add");

	$RETURN_URL = addrule($query);
	wr_debug("Redirect to: $RETURN_URL");
	print($query->redirect($RETURN_URL));

} elsif ($query->param('submit') =~ /Delete/) {
	wr_debug("It seems in this incarnation my purpose is to delete");

	$RETURN_URL = delrule($query);
	print($query->redirect("$RETURN_URL"));

} else {

	wr_debug("I don't exist - I do neither add nor delete it seems");
	exit(0);

}

sub addrule {
	$query = $_[0];

	$SRC = $query->param("src-net");
	$DEST = $query->param("dest-net");
	wr_debug("File to append to: $FWCONFIGTREE/rules/$SRC/$DEST/services.acl");
	wr_debug("To which I will append the following line:");
	$PERM = $query->param("perm");
	$SERVICE = $query->param("service");
	$SRC_GRP = $query->param("src_group");
	$DEST_GRP = $query->param("dest_group");
	$UTIME = time();
	wr_debug("$UTIME $PERM $SERVICE $SRC_GRP $DEST_GRP");
	append_file("$FWCONFIGTREE/rules/$SRC/$DEST/services.acl", "$UTIME $PERM $SERVICE $SRC $SRC_GRP $DEST $DEST_GRP");
	wr_debug("File has been appended to");

	return("/cgi-bin/ifrules.pl?myconfig=$MYCONFIG&src-net=$SRC&dest-net=$DEST&submit=View");

}

sub delrule {
	$query = $_[0];

	@DELALLTHESE = $query->param('rulecheck');

	$SRC = $query->param("src-net");
	$DEST = $query->param("dest-net");

	wr_debug("File to work through is $FWCONFIGTREE/rules/$SRC/$DEST/services.acl");

	@ALLRULES = read_file("$FWCONFIGTREE/rules/$SRC/$DEST/services.acl");

	open(FILE_FD, ">$FWCONFIGTREE/rules/$SRC/$DEST/services.acl");
	close(FILE_FD);

	foreach $LINE (@ALLRULES) {
		$RETVAL = check_match($LINE, @DELALLTHESE);

		if ($RETVAL) {
			wr_debug("Deleting line: $LINE");
		} else {
			append_file("$FWCONFIGTREE/rules/$SRC/$DEST/services.acl", "$LINE");
		}
	}


	return("/cgi-bin/ifrules.pl?myconfig=$MYCONFIG&src-net=$SRC&dest-net=$DEST&submit=View");
}
