#!/usr/bin/perl

##############################################################################
#
#	groupmod.pl	-	This CGI takes the Interface and either
#			"modify" or "create" as an argument.  It either displays
#			the networks and allows you to edit (in case of modify)
#			Or allows you to create a group from scratch.
#
#	Author		-	Redvers Davies
#
#	$Id: groupmod.pl,v 1.6 1998/10/29 01:46:56 red Exp $
#
#	$Log: groupmod.pl,v $
#	Revision 1.6  1998/10/29 01:46:56  red
#	added GPL licence
#
#	Revision 1.5  1998/10/29 00:43:08  red
#	Migrated subs to library
#
#	Revision 1.4  1998/10/27 20:20:38  red
#	added Config name so as to create multiple configs
#
#	Revision 1.3  1998/10/22 19:35:07  red
#	Stable version - no arch or name support
#
#	Revision 1.2  1998/10/08 20:46:44  red
#	Added "Main menu" link,
#	Added mkdir's for non-existant directories for new interfaces etc
#
#	Revision 1.1  1998/10/08 16:36:43  red
#	Initial revision
#
#
##############################################################################

##############################################################################
#
# MKLINUXFW - Modular Firewall Configuration Package
# Copyright Redvers Davies 1998
# 
#     This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# You can contact me by EMail at: red@madhouse.org.uk
#
##############################################################################



use CGI;
require "mklfwlib.pl";
$query = new CGI;

$MYCONFIG	=	$query->param("myconfig");
$FWCONFIGTREE	=	"/tmp/fwconfig/$MYCONFIG";
$DEBUG = 1;
$DEBUG_FILE	=	"/tmp/groupmod.debug";


$XX = $query->param("IF");
$YY = $query->param("hmm");

wr_debug("Started groupmod.pl");
wr_debug("$XX -> $YY\n\n");

if ($YY eq "modify") {
	modify_group($XX);
} elsif ($YY eq "create") {
	create_group($XX);
}

exit(0);

sub modify_group {
	$GROUP = join(//, @_);
	local @PARAMS	= ();

	wr_debug("modify_group($GROUP) is running");
	wr_debug("Getting list of pre-defined groups");
	wr_debug("Some HTML goes here");

	print("Content-type: text/html\n\n");
	print("<H1>Group you wish to modify?</h1>");

	wr_debug("So, lets get the list of groups for this device");

	@FILES = listfiles("$FWCONFIGTREE/groups/$GROUP");

	print("<form method=GET action=\"/cgi-bin/groupedit.pl\">\n");
	print("<input type=hidden name=myconfig value=$MYCONFIG>");
	print("<input type=hidden name=\"device\" value=\"$GROUP\">\n");
	push(@PARAMS, "groupname");

	foreach $LINE (@FILES) {
		push(@PARAMS, $LINE);
		push(@PARAMS, "$GROUP - $LINE");
	
	}

	print_twiddle(@PARAMS);
	print("<input type=submit value=\"Submit\">\n\n");
	print("</form>\n");
	print("<a href=\"/cgi-bin/main-menu.pl?$MYCONFIG\">Main Menu</a>\n");

}

sub create_group {
	$GROUP = join(//, @_);

	wr_debug("create_group($GROUP) is running");
	wr_debug("To run, simple touch the file and re-direct to the same cgi as modify");
	wr_debug("So.. lets mkdir the directories required");
	$RET = mkdir("$FWCONFIGTREE", 0755);
	$RET = mkdir("$FWCONFIGTREE/groups", 0755);
	$RET = mkdir("$FWCONFIGTREE/groups/$GROUP", 0755);
	if (!($RET)) {
		wr_debug("Failed mkdir with error $!");
	}

	print("Content-type: text/html\n\n");

	print("<h1>Name the group you wish to create:</h1>\n");
	print("<form method=GET action=\"/cgi-bin/groupedit.pl\">\n");
	print("<input type=hidden name=myconfig value=$MYCONFIG>");
	print("<input type=text name=groupname>\n");
	print("<input type=submit value=\"Submit\">\n");
	print("<input type=hidden name=\"device\" value=\"$GROUP\">\n");
	print("</form>\n");
	print("<a href=\"/cgi-bin/main-menu.pl?$MYCONFIG\">Main Menu</a>\n");
	
}
