#!/usr/bin/perl

##############################################################################
#
#	ifrules.pl	-	This CGI displays the current rules within
#				that classification and offers the ability to
#				configure/delete more.
#
#	Author		-	Redvers Davies
#
#	$Id: ifrules.pl,v 1.4 1998/10/31 14:36:14 red Exp red $
#
#	$Log: ifrules.pl,v $
#	Revision 1.4  1998/10/31 14:36:14  red
#	Added source and destination network to html table.
#	replaced explicit open,read,close,chop statements with read_file()
#
#	Revision 1.3  1998/10/29 01:46:56  red
#	added GPL licence
#
#	Revision 1.2  1998/10/29 00:39:01  red
#	Working version that adds and deletes rules but does no syntax checking
#
#	Revision 1.1  1998/10/22 19:35:07  red
#	Initial revision
#
#
##############################################################################

##############################################################################
#
# MKLINUXFW - Modular Firewall Configuration Package
# Copyright Redvers Davies 1998
# 
#     This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# You can contact me by EMail at: red@madhouse.org.uk
#
##############################################################################



require "mklfwlib.pl";
use CGI;

$query = new CGI;

$MYCONFIG	=	$query->param('myconfig');
$DEBUG = 1;
$DEBUG_FILE	=	"/tmp/ifrules.debug";
$FWCONFIGTREE	=	"/tmp/fwconfig/$MYCONFIG";

wr_debug("Starting ifrules.pl");

$SRC = $query->param('src-net');
$DEST = $query->param('dest-net');

wr_debug("Selecting Source LAN $SRC -> Dest LAN $DEST");
wr_debug("mkdiring the correct directory tree");
wr_debug("If it exists already - no harm done I guess");

$RET = mkdir("$FWCONFIGTREE/rules", 0755);
$RET = mkdir("$FWCONFIGTREE/rules/$SRC", 0755);
$RET = mkdir("$FWCONFIGTREE/rules/$SRC/$DEST", 0755);

wr_debug("Done...");

wr_debug("Let us read in the config which should be called services.acl");

system("/bin/touch $FWCONFIGTREE/rules/$SRC/$DEST/services.acl");

@ALL = read_file("$FWCONFIGTREE/rules/$SRC/$DEST/services.acl");

wr_debug("Read the config file");


print("Content-type: text/html\n\n");
print("<title>Manage services (Interfaces)</title>\n");
print("<h1>Manage Rules:</h1>\n");
print("<h2>Rules between Interfaces $SRC and $DEST</h2>\n");
print("<form method=GET action=\"/cgi-bin/doruleedit.pl\">\n");
print("<input type=hidden name=src-net value=$SRC><input type=hidden name=dest-net value=$DEST>\n");
print("<input type=hidden name=myconfig value=$MYCONFIG>\n");
print("<table><TR>\n");
print("<td>Delete?</td><td>Permission</td><td>Service</td><td>Source Net</td><td>Source Group</td><td>Destination Net</td><td>Destination Group</td>\n");
print("</TR>\n");

foreach $LINE_IN (@ALL) {
	wr_debug("Found RULE: $LINE_IN");
	($UTIME, $PERM, $SERVICE, $SRCNET, $SRCGROUP, $DESTNET, $DESTGROUP) = split(/ /, $LINE_IN);
	print("<TR>\n<td><input type=checkbox value=\"$UTIME\" name=\"rulecheck\"></td><td>$PERM</td><td>$SERVICE</td><td>$SRCNET</td><td>$SRCGROUP</td><td>$DESTNET</td><td>$DESTGROUP</td><td>$PROTOCOL</td><td>$PORT</td>\n");
	print("</tr>\n");
}

print("</table>\n");
print("<input type=\"submit\" name=\"submit\" value=\"Delete rule\">\n");

print("<br><hr><br>\n");
print("<h2>Add Rules:</h2>\n");
print("<table>\n");
print("<tr><td>Permission</td><td>Service</td><td>From</td><td>To</td></tr>\n");
print("<tr>\n");
print("<tr><td>");
print_twiddle("perm", "allow", "ALLOW", "deny", "DENY", "reject", "REJECT");
print("</td>\n");
print("<td>");

## Here, we find the list of valid services:
@FILES = listfiles("$FWCONFIGTREE/services");

@PARAMS = ();
push(@PARAMS, "service");
foreach $LINE (@FILES) {
	push(@PARAMS, $LINE);
	push(@PARAMS, $LINE);
}
print_twiddle(@PARAMS);
print("</td><td>\n");

## Next - we get the list of groups on that interface $SRC
@FILES = listfiles("$FWCONFIGTREE/groups/$SRC");

@PARAMS = ();
push(@PARAMS, "src_group");
foreach $LINE (@FILES) {
	push(@PARAMS, $LINE);
	push(@PARAMS, $LINE);
}
print_twiddle(@PARAMS);
print("</td><td>");

## Next - we get the list of groups on that interface $DEST
@FILES = listfiles("$FWCONFIGTREE/groups/$DEST");

@PARAMS = ();
push(@PARAMS, "dest_group");
foreach $LINE (@FILES) {
	push(@PARAMS, $LINE);
	push(@PARAMS, $LINE);
}
print_twiddle(@PARAMS);
print("</td></table>\n");
print("<input type=\"submit\" name=\"submit\" value=\"Add rule\">\n");

print("</form>\n");

print("<a href=\"/cgi-bin/main-menu.pl?$MYCONFIG\">Main Menu</a>\n");
