#!/usr/bin/perl

##############################################################################
#
#	main-menu.html	-	This CGI creates the main menu for group
#				modifications
#
#	Author		-	Redvers Davies
#
#	$Id: main-menu.pl,v 1.8 1998/10/31 12:35:56 red Exp red $
#
#	$Log: main-menu.pl,v $
#	Revision 1.8  1998/10/31 12:35:56  red
#	Forgot to add a hidden field in the third form
#
#	Revision 1.7  1998/10/30 00:42:11  red
#	Added "display by service"
#
#	Revision 1.6  1998/10/29 01:46:56  red
#	added GPL licence
#
#	Revision 1.5  1998/10/29 00:40:04  red
#	More migration of common subs to libraries
#
#	Revision 1.4  1998/10/27 20:21:22  red
#	added Config name so as to create multiple configs
#
#	Revision 1.3  1998/10/22 19:35:07  red
#	Stable version - no arch or name support.
#
#	Revision 1.2  1998/10/08 20:46:44  red
#	More HTML added and subroutined the IF selector.
#	Added Network Centric service selection
#
#	Revision 1.1  1998/10/08 16:36:43  red
#	Initial revision
#
#
##############################################################################

##############################################################################
#
# MKLINUXFW - Modular Firewall Configuration Package
# Copyright Redvers Davies 1998
# 
#     This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# You can contact me by EMail at: red@madhouse.org.uk
#
##############################################################################



require "mklfwlib.pl";

$MYCONFIG	=	$ARGV[0];
$HEAD_HTML	=	"/home/red/projects/mklinuxfw/html/main-head.html";
$MID_HTML	=	"/home/red/projects/mklinuxfw/html/main-mid.html";
$LAST_HTML	=	"/home/red/projects/mklinuxfw/html/main-last.html";
$DEBUG		=	1;
$DEBUG_FILE	=	"/tmp/mainmenu.debug";
$IF_DEFINITIONS	=	"/tmp/fwconfig/$MYCONFIG/if_definitions";
$FWCONFIGTREE	=	"/tmp/fwconfig/$MYCONFIG";

print("Content-type: text/html\n\n");

print_html_file("$HEAD_HTML");


print("<form method=GET action=\"/cgi-bin/groupmod.pl\">\n");
print("<input type=hidden name=myconfig value=$MYCONFIG>\n");
print("Interface: ");
print_if_option("IF");

print("<input type=\"submit\" name=\"hmm\" value=\"create\"><input name=\"hmm\" type=\"submit\" value=\"modify\">\n");
print("</form>\n");

print_html_file("$MID_HTML");

print("<form method=GET action=\"/cgi-bin/ifrules.pl\">\n");
print("<input type=hidden name=myconfig value=$MYCONFIG>\n");
print("<table><tr><td>Source Network</td><td>Destination Network</td></tr>\n");
print("<td>From: ");

print_if_option("src-net");

print("</td>\n<td>going to ");

print_if_option("dest-net", "1");

print("</td></tr></table>\n");

print("<input type=submit name=\"submit\" value=\"View/Modify rules for above combination\">");
print("</form>\n\n");

print("<h2>Service Centric</h2>\n");
print("<p>Display all rules for service</p>");

print("<form method=GET action=\"/cgi-bin/showservices.pl\">\n");
@FILES = listfiles("$FWCONFIGTREE/services");
@PARAMS = ();
push(@PARAMS, "service");
foreach $LINE (@FILES) {
	push(@PARAMS, $LINE);
	push(@PARAMS, $LINE);
}
print_twiddle(@PARAMS);
print("<input type=hidden name=myconfig value=\"$MYCONFIG\">");
print("<input type=submit name=submit value=\"Display all rules for service\">\n");
print("</form>\n");





sub print_if_option {
	local	@PARAMS = ();
	local	$NAME = $_[0];
	local	$LOSE_BLUE = $_[1];
	push(@PARAMS, "$NAME");

	open(IF_DEFINITIONS_FD, "$IF_DEFINITIONS");
	while($LINE_IN = <IF_DEFINITIONS_FD>) {

		if ($LINE_IN =~ /^\#/) {
			next;
		}

		$LINE_IN =~ /(\S+):(\S+) ## (.*)/;
		$COLOUR = $1;
		$DEVICE = $2;
		$LANNAME = $3;
		
		if ((!($LOSE_BLUE) || (!($COLOUR =~ /blue/)))) {
			wr_debug("Found: $COLOUR $DEVICE $LANNAME");
			push(@PARAMS, $DEVICE);
			push(@PARAMS, "$DEVICE - $COLOUR - $LANNAME");
		}

	}
	print_twiddle(@PARAMS);
}

