##############################################################################
#
#	mklfwlib.pl	-	A simple library which contains all the common
#				code for the cgi's.
#
#	Author		-	Redvers Davies
#
#	$Id: mklfwlib.pl,v 1.5 1998/10/31 14:37:21 red Exp red $
#
#	$Log: mklfwlib.pl,v $
#	Revision 1.5  1998/10/31 14:37:21  red
#	added read_file()
#
#	Revision 1.4  1998/10/31 12:36:25  red
#	added more subroutines to support showservices.pl
#
#	Revision 1.3  1998/10/29 01:46:56  red
#	added GPL licence
#
#	Revision 1.2  1998/10/29 00:42:10  red
#	Added print_html_file listfiles print_twiddle append_file check_syntax check_match
#
#	Revision 1.1  1998/10/22 19:35:07  red
#	Initial revision
#
#
##############################################################################

##############################################################################
#
# MKLINUXFW - Modular Firewall Configuration Package
# Copyright Redvers Davies 1998
# 
#     This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# You can contact me by EMail at: red@madhouse.org.uk
#
##############################################################################



sub print_html_file {
	$FILENAME = $_[0];
	open(HEAD_HTML_FD, "$FILENAME");
	@ALL = <HEAD_HTML_FD>;
	print("@ALL\n\n");
}

sub listfiles {
	local $PATH = $_[0];
	opendir(DIR, $PATH) || die "Ugh - cant list dir $PATH $!";
	@FILES = grep { /^./ && -f "$PATH/$_" } readdir(DIR);
	closedir(DIR);

	return(@FILES);
}

sub print_twiddle {
	local ($HTML_NAME, %OPTIONS_LIST) = @_;
	print("<select name=\"$HTML_NAME\">\n");

	foreach $KEY (keys %OPTIONS_LIST) {
		print("<option value=\"$KEY\">$OPTIONS_LIST{\"$KEY\"}\n");
	}
	print("</select>\n");
}
	
sub append_file {
	($FILE, @DATA) = @_;
	$IP = join(//, @DATA);
	wr_debug("File to append to is: $FILE (append_file)");
	open(FILE_FD, ">>$FILE");
	print(FILE_FD "$IP\n");
	close(FILE_FD);
}

sub check_syntax {
	$LINE_IN = join(//, @_);

	if ($LINE_IN !~ /\d+\.\d+\.\d+\.\d+\/\d+/) {
		wr_debug("$LINE_IN Failed IP verification");
		return(0);
	} else {
		wr_debug("$LINE_IN Passed IP verification");
		return("$LINE_IN");
	}
}

sub check_match {
	($LINE_IN, @CHECK_LIST) = @_;

	$TOTAL = 0;

	foreach $WORD (@CHECK_LIST) {
		$COUNT = $LINE_IN =~ /$WORD/i;
		$TOTAL += $COUNT;
	}
	return($TOTAL);
}

sub wr_debug {
	if ($DEBUG) {
		$MESSAGE = join(//, @_);
		open(DEBUG_FILE_FD, ">>$DEBUG_FILE");
		print(DEBUG_FILE_FD "$MESSAGE\n");
		close(DEBUG_FILE_FD);
	}
}

sub get_interfaces {
	@INTERFACES = ();

	open(IF_DEFINITIONS_FD, "$IF_DEFINITIONS");
	@IF_DEF_CONTENTS = <IF_DEFINITIONS_FD>;
	close(IF_DEFINITIONS_FD);

	foreach $LINE_IN (@IF_DEF_CONTENTS) {

		if (!($LINE_IN =~ /^#/)) {
			## Line is Valid... Match it:
			$LINE_IN =~ /^(\S+):(\S+) \#\#/;
			$COLOUR = $1;
			$IF = $2;
			push(@INTERFACES, $IF);
			wr_debug("Found Interface Definition: $IF");
		}
	}
	return(@INTERFACES);
}

sub uniq_hash_rules {
	@INTERFACES = @_;
	@RULES_FILES = ();

	foreach $SRC_NET (@INTERFACES) {
		foreach $DEST_NET (@INTERFACES) {

		if ($SRC_NET ne $DEST_NET) {
				push(@RULES_FILES, "$FWCONFIGTREE/rules/$SRC_NET/$DEST_NET/services.acl");
			}
		}
	}
	return(@RULES_FILES);
}

sub match_in_rule_file {
	($FIELD_NUM, $TO_MATCH, $SERVICE_FILE) = @_;
	$FIELD_NUM--;		# Cos arrays start at 0 not 1.
	@RULES_TO_MATCH = ();
	wr_debug("match_in_rule_file($FIELD_NUM, $TO_MATCH, $SERVICE_FILE) executed");

	open(SERVICE_FILE_FD, "$SERVICE_FILE");
	@SERVICE_FILE_CONTENTS = <SERVICE_FILE_FD>;
	close(SERVICE_FILE_FD);

	foreach $LINE_IN (@SERVICE_FILE_CONTENTS) {
		@LINE_FIELDS = split(/ /, $LINE_IN);

		if ($LINE_FIELDS[$FIELD_NUM] eq $TO_MATCH) {
			wr_debug("Match: $LINE_IN");
			push(@RULES_TO_MATCH, $LINE_IN);
		} else {
			wr_debug("$TO_MATCH != $LINE_FIELDS[$FIELD_NUM]");
		}
	}
	return(@RULES_TO_MATCH);
}

sub read_file {
	$FILENAME = @_[0];
	open(FILENAME_FD, "$FILENAME");
	@RETURN_ME = <FILENAME_FD>;
	close(FILENAME_FD);
	chop(@RETURN_ME);
	return(@RETURN_ME);
}


1;
