#!/usr/bin/perl

##############################################################################
#
#	recieve-interfaces.pl	-	This CGI parses the first page of
#		which defines how many interfaces you are going to define
#		and whether they are Red, Blue etc etc etc...
#
#	Author	-	Redvers Davies
#
#	$Id: recieve-interfaces.pl,v 1.5 1998/10/29 01:46:56 red Exp $
#
#	$Log: recieve-interfaces.pl,v $
#	Revision 1.5  1998/10/29 01:46:56  red
#	added GPL licence
#
#	Revision 1.4  1998/10/27 20:21:53  red
#	added Config name so as to create multiple configs
#
#	Revision 1.3  1998/10/22 19:35:07  red
#	Stable version - no arch or name support
#
#	Revision 1.2  1998/10/08 20:46:44  red
#	Changed the re-direct from static main-menu html to point at cgi
#
#	Revision 1.1  1998/10/06 15:30:18  red
#	Initial revision
#
#
##############################################################################

##############################################################################
#
# MKLINUXFW - Modular Firewall Configuration Package
# Copyright Redvers Davies 1998
# 
#     This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# You can contact me by EMail at: red@madhouse.org.uk
#
##############################################################################



use CGI;
require "mklfwlib.pl";

$query = new CGI;

$MYCONFIG	=	$query->param("myconfig");
$DEBUG_FILE	=	"/tmp/ri.cgi.debug";
$DEBUG		=	1;
$NUM_IFS	=	6;
$IF_DEFINITIONS	=	"/tmp/fwconfig/$MYCONFIG/if_definitions";


wr_debug("\n\n\nStarting recieve-interfaces.pl");

$NUL = mkdir("/tmp/fwconfig", 0755);
$NUL = mkdir("/tmp/fwconfig/$MYCONFIG", 0755);

%STATES = ();
open(IF_DEFINITIONS_FD, ">$IF_DEFINITIONS");
print(IF_DEFINITIONS_FD "## IF_DEFINITIONS File, in here we set which interfaces are on what type\n");
print(IF_DEFINITIONS_FD "## of LANS.\n#\n");
print(IF_DEFINITIONS_FD "#  In the form:\n# red:eth0\n");

foreach $NUM (1..$NUM_IFS) {
	wr_debug("Parseing Interface $NUM");
	
	$TMPNAME = $query->param("if$NUM-name");
	$TMPSTATUS = $query->param("IF$NUM-status");
	$TMPTEXT = $query->param("if$NUM-text");
	wr_debug("$NUM: $TMPSTATUS:$TMPNAME:$TMPTEXT");
	if ($TMPSTATUS eq "unused") {
		## Skip the print
	} else {
		print(IF_DEFINITIONS_FD "$TMPSTATUS:$TMPNAME ## $TMPTEXT\n");
	}
}

close(IF_DEFINITIONS_FD);

## Now the config file is written - lets re-direct to a static HTML main
## Menu.

print $query->redirect("/cgi-bin/main-menu.pl?$MYCONFIG");

