#!/usr/bin/perl

##############################################################################
#
#	showservices.pl	-	Display permissions per service.
#
#	Author		-	Redvers Davies	
#
#	$Id: showservices.pl,v 1.2 1998/10/31 14:40:19 red Exp red $
#
#	$Log: showservices.pl,v $
#	Revision 1.2  1998/10/31 14:40:19  red
#	added src and dest network to show-services table
#
#	Revision 1.1  1998/10/31 12:31:28  red
#	Initial revision
#
#
##############################################################################

##############################################################################
#
# MKLINUXFW - Modular Firewall Configuration Package
# Copyright Redvers Davies 1998
# 
#     This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# You can contact me by EMail at: red@madhouse.org.uk
#
##############################################################################

require "mklfwlib.pl";

use CGI;
$query = new CGI;

$MYCONFIG	=	$query->param('myconfig');
$DEBUG		=	1;
$DEBUG_FILE	=	"/tmp/showservices.debug";
$FWCONFIGTREE	=	"/tmp/fwconfig/$MYCONFIG";
$IF_DEFINITIONS	=	"$FWCONFIGTREE/if_definitions";


wr_debug("Started showservices.pl...");

wr_debug("Useing the following variables:");
wr_debug("Fir firewall config: $MYCONFIG");
$SERVICE = $query->param('service');
wr_debug("Display all rules using service: $SERVICE");

wr_debug("How many interfaces do we have configured?");
@INTERFACES = get_interfaces();
wr_debug("Found: @INTERFACES");

wr_debug("Specifying services files to \"grep\"");

@RULES_FILES = uniq_hash_rules(@INTERFACES);
wr_debug("Parsing files: @RULES_FILES");

@RULES_TO_DISPLAY = ();

foreach $RULE_FILE (@RULES_FILES) {
	@RULES_THAT_MATCH = match_in_rule_file(3, $SERVICE, $RULE_FILE);
	push(@RULES_TO_DISPLAY,  @RULES_THAT_MATCH);
}



wr_debug("@RULES_TO_DISPLAY");

print("Content-type: text/html\n\n");
print("<title>Matching rules for service: $SERVICE</title>\n");
print("<h1>Matching rules for service: $SERVICE</h1>\n");
print("<table><TR>\n");
print("<td>Permission</td><td>Service</td><td>Source Net</td><td>Source Group</td><td>Destination Net</td><td>Destination Group</td>\n");
print("</TR>\n");

foreach $LINE_IN (@RULES_TO_DISPLAY) {
	($UTIME, $PERM, $SERVICE, $SRCNET, $SRCGROUP, $DESTNET, $DESTGROUP) = split(/ /, $LINE_IN);
	print("<TR>\n<td>$PERM</td><td>$SERVICE</td><td>$SRCNET</td><td>$SRCGROUP</td><td>$DESTNET</td><td>$DESTGROUP</td><td>$PROTOCOL</td><td>$PORT</td>\n");
	print("</tr>\n");
}

print("</table>\n");

print("<a href=\"/cgi-bin/main-menu.pl?$MYCONFIG\">Main Menu</a>\n");
